package com;
import java.io.*;
/**
 * Crea una teoria logica prolog di regole e fatti dei clienti
 * @author  Raffaele
 */
public class Theory{

	String fatti,template,outputFile,line;
    String path ="../progetto/simulazione/";
	public Theory(String fatti, String template, String outputFile){
		this.fatti=fatti;
		this.template=template;
		this.outputFile=outputFile;
        PrintWriter prw = creaFile(path+outputFile);
        scrivi(prw,template);
        scrivi(prw,fatti);
        prw.close();
    }


 public void scrivi(PrintWriter prw, String inputFile){
	try{
        FileReader fr = new FileReader(inputFile);
		BufferedReader inFile = new BufferedReader(fr);
		line = inFile.readLine();
		prw.println();
		while(line != null){
             prw.println(line);
             line = inFile.readLine();
        }//while

		}catch(IOException e ){System.err.println("Non sono riuscito a creare il file!");}

    }//scrivi


    public PrintWriter creaFile(String outputFile){
		  PrintWriter outFile=null;
   	  try{
	  	 FileWriter fw = new FileWriter(outputFile,true);
	     BufferedWriter bw = new BufferedWriter (fw);
	     outFile = new PrintWriter (bw);
	     }
	     catch(IOException e ){System.err.println("Non sono riuscito a creare il file!");}
	     return outFile;
      }//creaFile


}//Theory