%
% Template di un agente bancario: direttore
% concede o no il servizio di mutuo 

% Author Raffaele Boschetti - 9/12/2004


agente:-

%Carica la libreria Tucson2PLibrary.
load_library('alice.tucson.api.Tucson2PLibrary'),
enter_context([agent_id(admin)]),
mutuo_service.



mutuo_service:- 
banca ? in(mutuo(ID,S)),
banca ? out(request(ID,casa)), 
eseguo(ID,S),
mutuo_service.	



eseguo(ID,S):-
banca ? rd(casa(Q)), 
Q == no,!,
(banca ? out(transaction(failed,'no assurance')));
(banca ? out(test(ID,casa,S)), banca ? out(bilancio(conto,cassa)),result(ID,S)). 



result(ID,S):-

banca ? in(assurance(A)),
banca ? in(red_balance(Conto,Cassa)),
(A==sufficient,Conto<6,Cassa<3),!, 
(ID ? out(prestito(S)), banca ? out(transaction(success)));      
(banca ? out(transaction(failed,'I do not trust you!'))).


 