%
% Template di un agente bancario: bancario
% effettua il prelievo bancomat dal conto del cliente 

% Author Raffaele Boschetti - 19/11/2004


agente:-

%Carica la libreria Tucson2PLibrary.
load_library('alice.tucson.api.Tucson2PLibrary'),
enter_context([agent_id(bancario)]),
bancomat_service.



bancomat_service:- 

banca ? in(bancomat(ID,S)),
banca ? out(test(ID,bancomat,S)),  
eseguo(ID),
bancomat_service.	



eseguo(ID):-
banca ? in(update(R,P)), 
P == commit,!,
(ID ? out(conto(R)),!, banca ? out(transaction(success)));
(P == red,!,
 ID ? out(conto(R)), banca ? out(update(abort)));
(ID ? out(conto(R)), banca ? out(transaction(failed))). 


