%
% Template di un agente bancario: bilancio
% monitora la storia finanziaria del cliente 

% Author Raffaele Boschetti - 9/12/2004



agente:-

%Carica la libreria Tucson2PLibrary.
load_library('alice.tucson.api.Tucson2PLibrary'),
enter_context([agent_id(bilancio)]),
assertz(conto(0)),
assertz(cassa(0)),
calculate.


conta_conto:-
banca ? in(bilancio(conto,cassa)),
(banca ? rdp(update(abort))),!, 
(banca ? inp(in_all(update(abort),[H|T])),red_conto([H|T]));
true.

red_conto([H|T]):-
conto(N),!,
(lista_length([H|T],Ris),
 N1 is N + Ris,
 retract(conto(N)),
 assertz(conto(N1))).
 
 
 
 conta_cassa:-
 banca ? rdp(money(insufficient)),!,
 (banca ? inp(in_all(money(insufficient),[H|T])),red_cassa([H|T]));
 true.
 
 
 red_cassa([H|T]):-
 cassa(N),!,
 (lista_length([H|T],Ris),
  N1 is N + Ris,
  retract(cassa(N)),
  assertz(cassa(N1))).
  
 
 
 

 verifica:-
     conto(Conto),cassa(Cassa),
     banca ? out(red_balance(Conto,Cassa)),
     calculate.
 
  
  calculate:-
       conta_conto,
       conta_cassa,
       verifica.
      
      
      
 lista_length([],0).
 lista_length([H|T],L):-
                lista_length(T,L1),
                L is L1+1.
 
 


 

