%
% Template di un agente bancario: il contabile
% verifica le propriet del cliente e si coordina con 
% tutti gli agenti bancari

% Author Raffaele Boschetti - 25/11/2004

 agente:- 
 load_library('alice.tucson.api.Tucson2PLibrary'),
 enter_context([agent_id(verifier)]),
 verify_service.
 
 
 verify_service:-
 banca ? in(test(ID,Service,S)),
 test(ID,Service,S),
 verify_service.


test(ID,bancomat,S):- 
 ID ? in(conto(Z)),
  Z>S,!, 
  (R is Z-S ,!, banca ? out(update(R,commit)));
  (Z==S,!,
   R is Z-S ,!, banca ? out(update(R,red)));
  (R is Z ,!, banca ? out(update(R,abort))). 
  
  
  
 test(ID,casa,S):-
 banca ? in(casa(Value)),
  Value>=S,!, 
  (banca ? out(assurance(sufficient)));
  (banca ? out(assurance(insufficient))). 
  
  
  
  test(ID,cassa,S):-
   ID ? in(cassa(C)),
   C>S,!, 
  (R is C-S ,!, banca ? out(cash(R,commit)));
  (C==S,!,
   R is C-S ,!, banca ? out(cash(R,red)));
  (R is C ,!, banca ? out(cash(R,abort))).
  
  
 
  