
%
% Template di un agente bancario: versamento
% esegue il versamento nel conto o nella cassa
% del cliente 

% Author Raffaele Boschetti - 2/12/2004

agente:-

%Carica la libreria Tucson2PLibrary.
load_library('alice.tucson.api.Tucson2PLibrary'),
enter_context([agent_id(versamento)]),
versamento_service.



versamento_service:- 
banca ? in(versamento(ID,Service,S)),
eseguo(ID,Service,S),
versamento_service.	


eseguo(ID,conto,S):-
(banca ? rd(cliente(ID)),S>0),!,
(ID ? in(conto(N)),
 N1 is N+S,
 ID ? out(conto(N1)),
 banca ? out(transaction(success)));
 banca ? out(transaction(failed, 'invalid import')).
 

eseguo(ID,cassa,S):-
(banca ? rd(cliente(ID)),S>0),!,
(ID ? in(cassa(C)),
 C1 is C+S,
 ID ? out(cassa(C1)),
 banca ? out(transaction(success)));
 banca ? out(transaction(failed, 'invalid import')).
 

