%
% Template di un agente bancario: prelievo
% effettua il prelievo dalla cassa del cliente 

% Author Raffaele Boschetti - 23/11/2004

agente:-

%Carica la libreria Tucson2PLibrary.
load_library('alice.tucson.api.Tucson2PLibrary'),
enter_context([agent_id(prelievo)]),
cassa_service.



cassa_service:- 

banca ? in(prelievo(ID,S)),
banca ? out(test(ID,cassa,S)),   
eseguo(ID),
cassa_service.	


eseguo(ID):-
banca ? in(cash(R,P)), 
P == commit,!,
(ID ? out(cassa(R)),!, banca ? out(transaction(success)));
(P == red,!,
 ID ? out(cassa(R)), banca ? out(money(insufficient)));
(ID ? out(cassa(R)), banca ? out(transaction(failed))). 

